#include <piece.h>
#include <string.h>
#include "pshell.h"

#define CHARACTERS 38	// t@CɎg镶F26 + 10 + 2

static int filenameInt[FILENAME_MAX - 1];	// Vt@C̕ԍ\
static int fileNameCursor;			// Vt@C͈̓ʒu

static int folders;				// tH_̃tH_
static int files;				// tH_̃t@C
static int sectors;				// tH_̃t@C̍vZN^

// t@C폜Tu[`
static void delete(FILE_ENTRY *file){

  // qΎq폜
  while(file->child != NULL){
    delete(file->child);
  }

  if(file->type != FOLDER){
    pceFileDelete(file->name);
  }
  deleteEntry(file);
}

// t@CsłȂׂ
static BOOL isValidFileName(const char *fileName){
  int i;

  i = 0;
  while((*fileName != '.') && (*fileName != '\0')){
    fileName++;
    i++;
  }

  // O1`8łȂFALSE
  if((i < 1) || (8 < i)){
    return FALSE;
  }

  // gq
  if(*fileName == '.'){
    fileName++;

    i = 0;
    while((*fileName != '.') && (*fileName != '\0')){
      fileName++;
      i++;
    }

    // gq1`3łȂFALSE
    if((i < 1) || (3 < i)){
      return FALSE;
    }
  }

  // ]vȕcĂFALSE
  if(*fileName){
    return FALSE;
  }
  else{
    return TRUE;
  }
}

// t@C̕ۑꏊT
static DIRECTORY *searchFileName(pffsMASTERBLOCK *masterBlock, const char *fileName){
  DIRECTORY *p;

  p = masterBlock->dir;

  while(strcmp(p->name, fileName) != 0){
    p++;
  }

  return p;
}

// tH_̎擾
void getFolderInfomation(FILE_ENTRY *folder){
  FILE_ENTRY *file;

  file = folder->child;

  while(file != NULL){
    if(file->type == FOLDER){
      folders++;
      getFolderInfomation(file);
    }else{
      files++;
      sectors += file->sectors;
    }

    file = file->next;
  }
}

////////////////////////////////////////////////////////////////////////////////

// t@C\
void fileInfomation(void){
  if(draw){

    // EBhE̘g
    pceLCDPaint(3, 0, 17, 128, 55);
    pceLCDPaint(0, 1, 18, 126, 53);

    // ACR̘g
    pceLCDPaint(3, 10, 20, 34, 34);

    // st@CȂACR\
    if(currentFile->type == PEX){
      printIcon(11, 21, currentFile->name);
    }
    else{
      pceLCDPaint(0, 11, 21, 32, 32);
    }

    pceFontSetPos(58 + 5 * (12 - strlen(currentFile->name)), 20);
    pceFontPrintf("%s", currentFile->name);

    pceFontSetPos(53, 32);
    pceFontPrintf("%7doCg", currentFile->size);

    pceFontSetPos(73, 44);
    pceFontPrintf("%3dZN^", currentFile->sectors);

    pceFontSetPos(64 - 2.5 * strlen(currentFile->caption), 61);
    pceFontPrintf("%s", currentFile->caption);
  }

  // {^Ζ߂
  if(pad & TRG_ANY){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}

// tH_\
void folderInfomation(void){
  if(draw){
    folders = 0;
    files = 0;
    sectors = 0;

    // tH_̎擾
    getFolderInfomation(currentFile);

    // EBhE̘g
    pceLCDPaint(3, 0, 18, 127, 52);
    pceLCDPaint(0, 1, 19, 125, 50);

    pceFontSetPos(64 - 2.5 * strlen(currentFile->caption), 19);
    pceFontPrintf("%s", currentFile->caption);

    pceFontSetPos(26, 39);
    pceFontPrintf("tH_F%3d", folders);

    pceFontSetPos(26, 49);
    pceFontPrintf("t@CF%3d", files);

    pceFontSetPos(26, 59);
    pceFontPrintf("ZN^@F%3d", sectors);
  }

  // {^Ζ߂
  if(pad & TRG_ANY){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}

// t@CύX̏
void prepareFileRename(void){
  copyMode = FALSE;

  // Vt@C
  fileNameCursor = 0;
  filenameInt[0] = 0;

  // t@C͂
  nextFunction = inputFileName;
  drawNext = TRUE;
}

// t@CRs[̏
void prepareFileCopy(void){

  // 󂫗eʂȂ΃bZ[W\
  if(currentFile->sectors > freeSectors){
    nextFunction = flashShortageDialog;
    drawNext = TRUE;
  }

  // 󂫗eʂĂ΃t@C͂
  else{
    copyMode = TRUE;

    // Vt@C
    fileNameCursor = 0;
    filenameInt[0] = 0;

    nextFunction = inputFileName;
    drawNext = TRUE;
  }
}

// t@C
void inputFileName(void){
  char character[] = "abcdefghijklmnopqrstuvwxyz0123456789_.";
  int i;

  // Eœ͈ʒuړ
  if((pad & TRG_RI) && (fileNameCursor < FILENAME_MAX - 2)){
    fileNameCursor++;
    filenameInt[fileNameCursor] = 0;
    draw = TRUE;
  }
  else if((pad & TRG_LF) && (fileNameCursor > 0)){
    fileNameCursor--;
    draw = TRUE;
  }

  // ㉺œ͕ύX
  if(pad & PAD_UP){
    filenameInt[fileNameCursor]--;
    draw = TRUE;
  }
  else if(pad & PAD_DN){
    filenameInt[fileNameCursor]++;
    draw = TRUE;
  }

  // ͕̓[v
  if(filenameInt[fileNameCursor] < 0){
    filenameInt[fileNameCursor] = CHARACTERS - 1;
  }
  else if(filenameInt[fileNameCursor] > CHARACTERS - 1){
    filenameInt[fileNameCursor] = 0;
  }

  // ωƂ̂݉ʂXV
  if(draw){

    // t@Cɂĕ\ς
    if(copyMode){

      // EBhE̘g
      pceLCDPaint(3, 8, 33, 112, 22);
      pceLCDPaint(0, 9, 34, 110, 20);

      pceFontSetPos(9, 34);
      pceFontPrintf("Rs[F%s", currentFile->name);
      pceFontSetPos(9, 44);
      pceFontPrintf("Rs[F");
    }
    else{

      // EBhE̘g
      pceLCDPaint(3, 13, 33, 103, 22);
      pceLCDPaint(0, 14, 34, 101, 20);

      pceFontSetPos(14, 34);
      pceFontPrintf("ύXOF%s", currentFile->name);
      pceFontSetPos(14, 44);
      pceFontPrintf("ύXF");
    }

    // J[\ʒuO܂ł̕
    for(i = 0; i < fileNameCursor; i++){
      pceFontPrintf("%c", character[filenameInt[i]]);
    }

    // J[\ʒu̕
    pceFontSetTxColor(0);
    pceFontSetBkColor(3);
    pceFontPrintf("%c", character[filenameInt[fileNameCursor]]);
    pceFontSetTxColor(3);
    pceFontSetBkColor(0);
  }

  // `{^Ō
  if(pad & TRG_A){

    // ԍ\當ɕϊ
    for(i = 0; i < fileNameCursor + 1; i++){
      newFileName[i] = character[filenameInt[i]];
    }
    newFileName[fileNameCursor + 1] = '\0';

    // t@C`FbN
    nextFunction = checkFileName;
    drawNext = TRUE;
  }

  // a{^ŃLZ
  else if(pad & TRG_B){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}

// t@C`FbN
void checkFileName(void){

  // Vt@C"startup.pex"Ȃ烁bZ[W\
  if(strcmp(newFileName, "startup.pex") == 0){
    nextFunction = startupPexDialog;
    drawNext = TRUE;
  }

  // t@CƐVt@CȂ烁bZ[W\
  else if(strcmp(currentFile->name, newFileName) == 0){
    nextFunction = fileNameOverlapDialog;
    drawNext = TRUE;
  }

  // Õt@CΊmFbZ[W\
  else if(searchEntry(root, newFileName)){
    nextFunction = overWriteFileDialog;
    drawNext = TRUE;
  }

  // Vt@CsȂ烁bZ[W\
  else if(!isValidFileName(newFileName)){
    nextFunction = invalidFileNameDialog;
    drawNext = TRUE;
  }

  // 肪ȂΎs
  else{
    if(copyMode){
      nextFunction = copyFile;
    }
    else{
      nextFunction = renameFile;
    }
  }
}

// t@CύX
void renameFile(void){
  DIRECTORY *pdir;
  pffsMASTERBLOCK *masterBlock;
  pffsMASTERBLOCK newMasterBlock;

  // ύX̃t@Cɑ݂ĂÃt@C폜
  if(searchEntry(root, newFileName)){
    pceFileDelete(newFileName);
  }

  // ǗubN擾
  masterBlock = (pffsMASTERBLOCK *)pceSystemGetInfo()->pffs_top;

  // ǗubNRs[
  memcpy(&newMasterBlock, masterBlock, sizeof(pffsMASTERBLOCK));

  // t@C̕ۑꏊT
  pdir = searchFileName(&newMasterBlock, currentFile->name);

  // t@CXV
  strncpy(pdir->name, newFileName, sizeof(pdir->name)-1);

  // ǗubNXV
  pceFlashErase(masterBlock);
  pceFlashWrite(masterBlock, &newMasterBlock, sizeof(pffsMASTERBLOCK));

  nextFunction = initialize;
}

// t@CRs[
void copyFile(void){
  FILEACC input, output;
  char fileBuffer[SECTOR_SIZE];
  int i;

  pceFileCreate(newFileName, currentFile->size);

  pceFileOpen(&input, currentFile->name, FOMD_RD);
  pceFileOpen(&output, newFileName, FOMD_WR);

  for(i = 0; i < currentFile->sectors; i++){
    pceFileReadSct(&input, fileBuffer, i, SECTOR_SIZE);
    pceFileWriteSct(&output, fileBuffer, i, SECTOR_SIZE);
  }

  pceFileClose(&input);
  pceFileClose(&output);

  nextFunction = initialize;
}

// t@C폜
void deleteFile(void){
  delete(currentFile);
  nextFunction = initialize;
}
