#include <piece.h>
#include <string.h>
#include "pshell.h"

void pceAppInit(void){
  pceLCDDispStop();
  pceLCDSetBuffer(vbuff);
  memset(vbuff, 0, DISP_X * DISP_Y);
  pceLCDDispStart();

  pceCPUSetSpeed(CPU_SPEED_HALF);
  pceAppSetProcPeriod(120);
  pcePadSetTrigMode(PP_MODE_SINGLE);
  pceFontSetType(0x80);

  root = newEntry();
  root->type = FOLDER;

  draw = FALSE;
  drawNext = FALSE;

  // tH_c[̏
  nextFunction = initialize;
}

void pceAppProc(int cnt){
  PCETIME time;
  static unsigned char ssOld = 0;
  PCEPWRSTAT ps;
  int voltage;
  static int voltageOld = 0;

  pad = pcePadGet();

  // ZNg{aŃX^oC
  if((pad & PAD_D) && (pad & TRG_B)){
    pad = 0;
    pcePowerEnterStandby(0);
  }

  nextFunction();

  // 擾
  pceTimeGet(&time);

  // ωʂXV
  if(time.ss != ssOld){
    ssOld = time.ss;
    draw = TRUE;
  }

  // dd擾
  pcePowerGetStatus(&ps);
  voltage = ps.battvol / 10.0 + 0.5;

  // ddωʂXV
  if(voltage != voltageOld){
    voltageOld = voltage;
    draw = TRUE;
  }

  // KvȂƂ̂݉ʂXV
  if(draw){

    // AddA󂫃ZN^\
    pceFontSetType(0x82);
    pceFontSetPos(0, 82);
    pceFontPrintf(
      "%04d/%02d/%02d %02d:%02d:%02d %1d.%02dV %3dsec",
      time.yy, time.mm, time.dd, time.hh, time.mi, time.ss,
      voltage / 100, voltage % 100, freeSectors
    );
    pceFontSetType(0x80);

    pceLCDTrans();
    draw = FALSE;
  }

  // 1XebvɍXVꍇ
  if(drawNext){
    draw = TRUE;
    drawNext = FALSE;
  }
}

void pceAppExit(void){

  // ̃vONOCPUxɖ߂
  pceCPUSetSpeed(CPU_SPEED_NORMAL);
}
