#include <piece.h>

#define PSHELL_VERSION "ver.1.70"	// o[W
#define FILENAME_MAX 13			// 8 + '.' + 3 + '\0'
#define CAPTION_MAX 26			// 25 + '\0'
#define SECTOR_SIZE 4096		// 1ZN^̃TCY
#define CONFIG_FILE "pshell.cfg"	// RtBOt@C
#define TRG_ANY 0xff00			// ꂩ̃{^ꂽ

// t@C^Cv
typedef enum {
  PEX,		// st@C
  DATA,		// st@C
  FOLDER	// tH_
} FILETYPE;

// t@CGg
typedef struct _FILE_ENTRY FILE_ENTRY;

struct _FILE_ENTRY{
  char name[FILENAME_MAX];		// t@C
  char caption[CAPTION_MAX];		// LvV
  FILETYPE type;			// t@C^Cv
  int size;				// t@CTCY
  int sectors;				// ZN^
  FILE_ENTRY *parent;			// eւ̃|C^
  FILE_ENTRY *child;			// qւ̃|C^
  FILE_ENTRY *previous;			// Zւ̃|C^
  FILE_ENTRY *next;			// ւ̃|C^
};

// t@C̐񏇏
typedef enum {
  NAME,			// t@C
  NAME_REVERSE,		// t@Ct
  TYPE,			// gq
  TYPE_REVERSE,		// gqt
  CAPTION,		// LvV
  CAPTION_REVERSE,	// LvVt
  SIZE,			// t@CTCY
  SIZE_REVERSE		// t@CTCYt
} SORT_MODE;

// O[oϐFvariable.cŒ`
////////////////////////////////////////////////////////////////////////////////

extern unsigned char vbuff[DISP_X * DISP_Y];	// zVRAM

extern void (*nextFunction)(void);		// Ɏs֐
extern unsigned long pad;			// pbh
extern BOOL draw;				// ݂̃XebvŉʂXV邩
extern BOOL drawNext;				// ̃XebvŉʂXV邩

extern FILE_ENTRY *root;			// [gtH_
extern FILE_ENTRY *program;			// tH_uvOv
extern FILE_ENTRY *uncategorizedProgram;	// tH_uvO/ށv
extern FILE_ENTRY *data;			// tH_uf[^v
extern FILE_ENTRY *uncategorizedData;		// tH_uf[^/ށv

extern FILE_ENTRY *currentFile;			// J[\ʒũt@C
extern int currentLevel;			// J[\ʒũtH_Kw
extern int screenPosition;			// JgtH_̕\W

extern int freeSectors;				// tbV̋󂫃ZN^
extern BOOL printSize;				// t@CTCY\邩
extern BOOL printSectors;			// t@C̃ZN^\邩
extern SORT_MODE sortMode;			// t@C̐񏇏

extern char newFileName[FILENAME_MAX];		// Rs[AύX̃t@C
extern BOOL copyMode;				// t@C삪Rs[Ȃ^AO̕ύXȂU

////////////////////////////////////////////////////////////////////////////////

// tree.c̊֐
FILE_ENTRY *newEntry(void);				// VKt@CGg쐬
void deleteEntry(FILE_ENTRY *file);			// t@CGg폜
void addEntry(FILE_ENTRY *folder, FILE_ENTRY *file);	// t@CGgtH_ɒǉ
void moveEntry(FILE_ENTRY *folder, FILE_ENTRY *file);	// t@CGgtH_Ɉړ
FILE_ENTRY *searchEntry(const FILE_ENTRY *folder, const char *fileName);
							// tH_̃t@CGgT
void sortFiles(void);					// t@C̐

// initialize.c̊֐
void initialize(void);					// tH_c[̏

// file.c̊֐
void getFiles(void);					// t@C̎擾
void printIcon(int x, int y, const char *fileName);	// ACR̕\

// config.c̊֐
void readConfigFile(void);				// RtBOt@C̓ǂݍ

// view.c̊֐
void printTitle(void);					// ^Cg
void viewFolderTree(void);				// C

// menu.c̊֐
void fileMenu(void);					// t@Cj[
void folderMenu(void);					// tH_j[
void systemMenu(void);					// VXej[

// dialog.c̊֐
void flashShortageDialog(void);				// eʕs_CAO
void startupPexDialog(void);				// startup.pex㏑֎~_CAO
void fileNameOverlapDialog(void);			// t@Cd_CAO
void invalidFileNameDialog(void);			// t@Cs_CAO
void overWriteFileDialog(void);				// t@C㏑mF_CAO
void deleteFileDialog(void);				// t@C폜mF_CAO
void deleteFolderDialog(void);				// tH_폜mF_CAO

// function.c̊֐
void fileInfomation(void);				// t@C\
void folderInfomation(void);				// tH_\
void prepareFileRename(void);				// t@CύX̏
void prepareFileCopy(void);				// t@CRs[̏
void inputFileName(void);				// t@C
void checkFileName(void);				// t@C`FbN
void renameFile(void);					// t@CύX
void copyFile(void);					// t@CRs[
void deleteFile(void);					// t@C폜

// system.c̊֐
void setVolume(void);					// ʒ
void setContrast(void);					// RgXg
void getTime(void);					// ݒ莞̏
void setTime(void);					// ݒ
