#include <piece.h>
#include "pshell.h"

#define VOLUME_MAX 9	// ʍőli\lj
#define VOLUME_MIN 0	// ʍŏli\lj

// ʕϊe[u
static int volumeMap[] = {
  99,		// 0
  127 - 90,	// 1
  127 - 97,	// 2
  127 - 103,	// 3
  127 - 107,	// 4
  127 - 111,	// 5
  127 - 115,	// 6
  127 - 119,	// 7
  127 - 123,	// 8
  127 - 127	// 9
};

// ݂̉ʂ̎擾
static int getVolume(void){
  int attenuation, volume;

  attenuation = pceWaveSetMasterAtt(INVALIDVAL);

  volume = VOLUME_MAX;
  while((volume > VOLUME_MIN) && (attenuation > volumeMap[volume])){
    volume--;
  }

  return volume;
}

// ʒ
void setVolume(void){
  int volume, volumeOld;

  volume = getVolume();
  volumeOld = volume;

  // EŒl̕ύX
  if((pad & PAD_LF) && (volume > VOLUME_MIN)){
    volume--;
  }
  else if((pad & PAD_RI) && (volume < VOLUME_MAX)){
    volume++;
  }

  // ωƂ̂݉ʂύXAʂXV
  if(volume != volumeOld){
    pceWaveSetMasterAtt(volumeMap[volume]);
    draw = TRUE;
  }

  if(draw){
    pceLCDPaint(3, 35, 37, 58, 13);
    pceLCDPaint(0, 36, 38, 56, 11);

    pceFontSetPos(36, 39);
    pceFontPrintf("%d  %d  %d", VOLUME_MIN, volume, VOLUME_MAX);
  }

  // `Aa{^Ŗ߂
  if(pad & (TRG_A | TRG_B)){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}

////////////////////////////////////////////////////////////////////////////////

#define CONTRAST_MAX 63	// RgXgőlilj
#define CONTRAST_MIN 25	// RgXgŏlilj

// RgXg
void setContrast(void){
  int contrast, contrastOld;

  contrast = pceLCDSetBright(INVALIDVAL);
  contrastOld = contrast;

  // EŒl̕ύX
  if((pad & PAD_LF) && (contrast > CONTRAST_MIN)){
    contrast--;
  }
  else if((pad & PAD_RI) && (contrast < CONTRAST_MAX)){
    contrast++;
  }

  // ωƂ̂݃RgXgύXAʂXV
  if(contrast != contrastOld){
    pceLCDSetBright(contrast);
    draw = TRUE;
  }

  if(draw){
    pceLCDPaint(3, 28, 37, 73, 13);
    pceLCDPaint(0, 29, 38, 71, 11);

    pceFontSetPos(29, 39);
    pceFontPrintf("%2d  %2d  %2d",
                  0, contrast - CONTRAST_MIN, CONTRAST_MAX - CONTRAST_MIN);
  }

  // `Aa{^Ŗ߂
  if(pad & (TRG_A | TRG_B)){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}

////////////////////////////////////////////////////////////////////////////////

#define TIME_ITEMS 5	// ̍ڐ

// ̍
typedef enum {
  YEAR,		// N
  MONTH,	// 
  DAY,		// 
  HOUR,		// 
  MINUTE	// 
} TIME_ITEM;

static int newTime[TIME_ITEMS];	// ύX̎̔z\
static TIME_ITEM timeCursor;	// ύX鎞̍

// ̍ڂ̕\
static void printTimeItem(const char *format, int value, TIME_ITEM timeItem){

  // J[\ʒuȂ甽]\
  if(timeItem == timeCursor){
    pceFontSetTxColor(0);
    pceFontSetBkColor(3);
  }

  pceFontPrintf(format, value);

  // ]\ɖ߂
  if(timeItem == timeCursor){
    pceFontSetTxColor(3);
    pceFontSetBkColor(0);
  }
}

// ݒ莞̏
void getTime(void){
  PCETIME time;

  // 擾
  pceTimeGet(&time);
  newTime[YEAR]   = time.yy;
  newTime[MONTH]  = time.mm;
  newTime[DAY]    = time.dd;
  newTime[HOUR]   = time.hh;
  newTime[MINUTE] = time.mi;

  // ͍ڂuNvɂ
  timeCursor = YEAR;

  nextFunction = setTime;
  drawNext = TRUE;
}

// ݒ
void setTime(void){
  PCETIME time;
  TIME_ITEM timeCursorOld;

  //             N        
  int min[] = {2000,  1,  1,  0,  0};	// eڂ̍ŏl
  int max[] = {2099, 12, 31, 23, 59};	// eڂ̍ől

  timeCursorOld = timeCursor;

  // EŐݒ荀ڂ̈ړ
  if((pad & TRG_RI) && (timeCursor < MINUTE)){
    timeCursor++;
  }
  else if((pad & TRG_LF) && (timeCursor > YEAR)){
    timeCursor--;
  }

  // ωƂ̂݉ʂXV
  if(timeCursor != timeCursorOld){
    draw = TRUE;
  }

  // ㉺Œl̕ύX
  if(pad & PAD_UP){
    newTime[timeCursor]++;
    draw = TRUE;
  }
  else if(pad & PAD_DN){
    newTime[timeCursor]--;
    draw = TRUE;
  }

  // eڂ̒l̓[v
  if(newTime[timeCursor] < min[timeCursor]){
    newTime[timeCursor] = max[timeCursor];
  }
  else if(newTime[timeCursor] > max[timeCursor]){
    newTime[timeCursor] = min[timeCursor];
  }

  if(draw){
    pceLCDPaint(3, 23, 37, 83, 13);
    pceLCDPaint(0, 24, 38, 81, 11);

    pceFontSetPos(24, 39);
    printTimeItem("%04d", newTime[YEAR], YEAR);
    pceFontPrintf("/");
    printTimeItem("%02d", newTime[MONTH], MONTH);
    pceFontPrintf("/");
    printTimeItem("%02d", newTime[DAY], DAY);
    pceFontPrintf(" ");
    printTimeItem("%02d", newTime[HOUR], HOUR);
    pceFontPrintf(":");
    printTimeItem("%02d", newTime[MINUTE], MINUTE);
  }

  // `{^Ō
  if(pad & TRG_A){

    // ݒ
    time.yy = newTime[YEAR];
    time.mm = newTime[MONTH];
    time.dd = newTime[DAY];
    time.hh = newTime[HOUR];
    time.mi = newTime[MINUTE];
    pceTimeSet(&time);

    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }

  // a{^ŃLZ
  else if(pad & TRG_B){
    nextFunction = viewFolderTree;
    drawNext = TRUE;
  }
}
