#include <piece.h>
#include <string.h>
#include "pshell.h"

// AXg2̑gi}[W\[gpj
typedef struct {
  FILE_ENTRY *list1;
  FILE_ENTRY *list2;
} TWIN_LIST;

////////////////////////////////////////////////////////////////////////////////

// i}[W\[gpj
static TWIN_LIST partition(FILE_ENTRY *list){
  int i, n;
  FILE_ENTRY *p;
  TWIN_LIST twinList;

  // AXg̗vf𐔂
  n = 1;
  p = list;
  while(p->next){
    p = p->next;
    n++;
  }

  // ̒n_𕪊_Ƃ
  n /= 2;

  p = list;
  for(i = 0; i < n; i++){
    p = p->next;
  }

  // AXg2
  p->previous->next = NULL;
  p->previous = NULL;
  twinList.list1 = list;
  twinList.list2 = p;

  return twinList;
}

// ri}[W\[gpj
static int compare(FILE_ENTRY *a, FILE_ENTRY *b){
  switch(sortMode){
    case NAME:
      return strcmp(a->name, b->name);
    case NAME_REVERSE:
      return strcmp(b->name, a->name);
    case TYPE:
      return strcmp(strchr(a->name, '.'), strchr(b->name, '.'));
    case TYPE_REVERSE:
      return strcmp(strchr(b->name, '.'), strchr(a->name, '.'));
    case CAPTION:
      return strcmp(a->caption, b->caption);
    case CAPTION_REVERSE:
      return strcmp(b->caption, a->caption);
    case SIZE:
      return a->size - b->size;
    case SIZE_REVERSE:
      return b->size - a->size;

    // warning̃_~[
    default:
      return 0;
  }
}

// }[Wi}[W\[gpj
static FILE_ENTRY *merge(FILE_ENTRY *list1, FILE_ENTRY *list2){
  FILE_ENTRY *mergedList, *p;

  // ŏ̗vf
  if(compare(list1, list2) > 0){
    mergedList = list2;
    list2 = list2->next;
  }
  else{
    mergedList = list1;
    list1 = list1->next;
  }
  mergedList->next = NULL;

  // QԖڈȍ~Alist1, list2ɗvf
  p = mergedList;
  while(list1 && list2){
    if(compare(list1, list2) > 0){
      p->next = list2;
      list2 = list2->next;
    }
    else{
      p->next = list1;
      list1 = list1->next;
    }

    p->next->previous = p;
    p = p->next;
    p->next = NULL;
  }

  // ȍ~
  if(list1){
    p->next = list1;
  }
  else{
    p->next = list2;
  }
  p->next->previous = p;

  return mergedList;
}

// }[W\[g
static FILE_ENTRY *mergeSort(FILE_ENTRY *list){
  TWIN_LIST twinList;

  if(list->next){
    twinList = partition(list);
    twinList.list1 = mergeSort(twinList.list1);
    twinList.list2 = mergeSort(twinList.list2);
    list = merge(twinList.list1, twinList.list2);
  }

  return list;
}

////////////////////////////////////////////////////////////////////////////////

// t@CGgtH_c[O
static void removeEntry(FILE_ENTRY *file){

  if(file->parent != NULL){
    if(file->previous != NULL){
      if(file->next != NULL){
        // e@Z@큛
        file->previous->next = file->next;
        file->next->previous = file->previous;
      }
      else{
        // e@Z@~
        file->previous->next = NULL;
      }
    }
    else{
      if(file->next != NULL){
        // e@Z~@큛
        file->parent->child = file->next;
        file->next->previous = NULL;
      }
      else{
        // e@Z~@~
        file->parent->child = NULL;
      }
    }
  }
  else{
    if(file->previous != NULL){
      if(file->next != NULL){
        // e~@Z@큛
        file->previous->next = file->next;
        file->next->previous = file->previous;
      }
      else{
        // e~@Z@~
        file->previous->next = NULL;
      }
    }
    else{
      if(file->next != NULL){
        // e~@Z~@큛
        file->next->previous = NULL;
      }
      else{
        // e~@Z~@~
      }
    }
  }


  // qȊOւ̃N
  file->parent = NULL;
  file->previous = NULL;
  file->next = NULL;
}

// ChJ[hɂ镶̔r
static BOOL stringMatch(const char *pattern, const char *string){
  switch(*pattern){

    case '\0':
      if(*string == '\0'){
        return TRUE;
      }else{
        return FALSE;
      }

    case '*':
      if(stringMatch(pattern + 1, string)
         || ((*string != '\0') && stringMatch(pattern, string + 1))){
        return TRUE;
      }else{
        return FALSE;
      }

    case '?':
      if((*string != '\0') && stringMatch(pattern + 1, string + 1)){
        return TRUE;
      }else{
        return FALSE;
      }

    default:
      if((*pattern == *string) && stringMatch(pattern + 1, string + 1)){
        return TRUE;
      }else{
        return FALSE;
      }
  }
}

////////////////////////////////////////////////////////////////////////////////

// VKt@CGg쐬
FILE_ENTRY *newEntry(void){
  FILE_ENTRY *f;

  f = (FILE_ENTRY *)pceHeapAlloc(sizeof(FILE_ENTRY));

  f->parent = NULL;
  f->child = NULL;
  f->previous = NULL;
  f->next = NULL;
  strcpy(f->name, "");
  strcpy(f->caption, "");

  return f;
}

// t@CGg폜
void deleteEntry(FILE_ENTRY *file){

  // qΎq폜
  while(file->child != NULL){
    deleteEntry(file->child);
  }

  // [g͍폜Ȃ
  if(file != root){
    removeEntry(file);
    pceHeapFree(file);
  }
}

// t@CGgtH_ɒǉ
void addEntry(FILE_ENTRY *folder, FILE_ENTRY *file){
  FILE_ENTRY *f;

  f = folder->child;

  if(f == NULL){
    folder->child = file;
  }
  else{
    while(f->next != NULL){
      f = f->next;
    }
    f->next = file;
    file->previous = f;
  }

  file->parent = folder;
}

// t@CGgtH_Ɉړ
void moveEntry(FILE_ENTRY *folder, FILE_ENTRY *file){
  removeEntry(file);
  addEntry(folder, file);
}

// tH_̃t@CGgT
FILE_ENTRY *searchEntry(const FILE_ENTRY *folder, const char *fileName){
  FILE_ENTRY *file, *subFile;

  file = folder->child;

  while(file != NULL){
    if(file->type == FOLDER){
      if((subFile = searchEntry(file, fileName)) != NULL){
        return subFile;
      }
    }else{
      if(stringMatch(fileName, file->name)){
        return file;
      }
    }

    file = file->next;
  }

  return NULL;
}

// t@C̐
void sortFiles(void){
  if(uncategorizedProgram->child){
    uncategorizedProgram->child = mergeSort(uncategorizedProgram->child);
  }

  if(uncategorizedData->child){
    uncategorizedData->child = mergeSort(uncategorizedData->child);
  }
}
