#include <piece.h>
#include <string.h>
#include "pshell.h"

// t@C\
static void printFile(int x, int y, const FILE_ENTRY *file){
  pceFontSetPos(5 * x + 1, 10 * y);

  // J[\ʒuȂ甽]\
  if(file == currentFile){
    pceFontSetTxColor(0);
    pceFontSetBkColor(3);
  }

  // LvV΃LvVAȂ΃t@C\
  if(strlen(file->caption) > 0){
    pceFontPrintf("%s", file->caption);
  }
  else{
    pceFontPrintf("%s", file->name);
  }

  // ]\ɖ߂
  if(file == currentFile){
    pceFontSetTxColor(3);
    pceFontSetBkColor(0);
  }

  if(file->type != FOLDER){

    // t@CTCY\
    if(printSize){
      pceFontSetPos(86, 10 * y);
      pceFontPrintf(" %7d ", file->size);
    }

    // ZN^\
    else if(printSectors){
      pceFontSetPos(106, 10 * y);
      pceFontPrintf(" %3d ", file->sectors);
    }
  }
}

// ʕ\
static void printScreen(void){
  FILE_ENTRY *f;
  int i, cursorPosition;

  // ʃNA
  pceLCDPaint(0, 0, 0, DISP_X, DISP_Y);

  // etH_\
  switch(currentLevel){
    case 2:
      printFile(0, 0, currentFile->parent);
      break;

    case 3:
      printFile(0, 0, currentFile->parent->parent);

      printFile(1, 1, currentFile->parent);
      break;
  }

  // Pʕ\
  if(currentLevel == 3){

    if(printSize){
      pceFontSetPos(101, 0);
      pceFontPrintf(" SIZE ");
    }

    else if(printSectors){
      pceFontSetPos(91, 0);
      pceFontPrintf(" SECTOR ");
    }
  }

  cursorPosition = 0;
  f = currentFile->parent->child;
  while(f != currentFile){
    f = f->next;
    cursorPosition++;
  }

  // ʃXN[
  while(cursorPosition > screenPosition + 8 - currentLevel){
    screenPosition++;
  }
  while(cursorPosition < screenPosition){
    screenPosition--;
  }

  f = currentFile->parent->child;
  for(i = 0; i < screenPosition; i++){
    f = f->next;
  }

  i = 0;
  while((f != NULL) && (i < 9 - currentLevel)){
    printFile(currentLevel - 1, currentLevel + i - 1, f);

    f = f->next;
    i++;
  }

  // XN[\Ȃ\
  if(screenPosition > 0){
    pceFontSetPos(61, 0);
    pceFontPrintf("");
  }
  if(f != NULL){
    pceFontSetPos(71, 0);
    pceFontPrintf("");
  }
}

////////////////////////////////////////////////////////////////////////////////

// ^Cg
void printTitle(void){
  if(draw){

    // ʃNA
    pceLCDPaint(0, 0, 0, DISP_X, DISP_Y);

    pceFontSetType(0x81);

    pceFontSetPos(36, 24);
    pceFontPrintf("P/SHELL");

    pceFontSetPos(32, 40);
    pceFontPrintf(PSHELL_VERSION);
  }
}

// C
void viewFolderTree(void){
  FILE_ENTRY *currentFileOld;

  currentFileOld = currentFile;

  // J[\ړ
  if((pad & PAD_UP) && (currentFile->previous != NULL)){
    currentFile = currentFile->previous;
  }
  if((pad & PAD_DN) && (currentFile->next != NULL)){
    currentFile = currentFile->next;
  }
  if((pad & TRG_RI) && (currentFile->child != NULL)){
    currentFile = currentFile->child;
    currentLevel++;
    screenPosition = 0;
  }
  if((pad & TRG_LF) && (currentFile->parent != root)){
    currentFile = currentFile->parent;
    currentLevel--;
    screenPosition = 0;
  }

  // ωƂ̂݉ʂXV
  if(currentFile != currentFileOld){
    draw = TRUE;
  }

  // ʕ\
  printScreen();

  // `{^ŃvOs
  if((pad & TRG_A) && (currentFile->type == PEX)){
    pceAppExecFile(currentFile->name, 0);
  }

  // a{^Ńt@Cj[\
  else if(pad & TRG_B){
    if(currentFile->type == FOLDER){
      nextFunction = folderMenu;
    }
    else{
      nextFunction = fileMenu;
    }

    drawNext = TRUE;
  }

  // X^[g{^ŃVXej[\
  else if(pad & TRG_C){
    nextFunction = systemMenu;
    drawNext = TRUE;
  }
}
